package ink.wgink.util.remote.rest;

import net.sf.cglib.proxy.Enhancer;
import net.sf.cglib.proxy.MethodInterceptor;
import net.sf.cglib.proxy.MethodProxy;

import java.lang.reflect.Method;

/**
 * @ClassName: RestRemoteRequest
 * @Description: rest远程请求
 * @Author: wanggeng
 * @Date: 2021/9/18 4:23 下午
 * @Version: 1.0
 */
public class RestRemoteRequestDemo implements MethodInterceptor {


    @Override
    public Object intercept(Object o, Method method, Object[] args, MethodProxy methodProxy) throws Throwable {
        return methodProxy.invokeSuper(o, args);
    }

    public static class RestRemoteRequestFactory {
        public static Object getProxy(Class<?> clazz) {
            Enhancer enhancer = new Enhancer();
            enhancer.setClassLoader(clazz.getClassLoader());
            enhancer.setSuperclass(clazz);
            enhancer.setCallback(new RestRemoteRequestDemo());
            return enhancer.create();
        }
    }

    public static class Demo {
        void say(String msg) {
            System.out.println(msg);
        }
    }

    public static void main(String[] args) {
        Demo demo = (Demo) RestRemoteRequestFactory.getProxy(Demo.class);
        demo.say("你好");
    }

}
