package ink.wgink.util.remote.rest.proxy;

import ink.wgink.util.remote.rest.handler.RestRemoteHandler;

import java.lang.reflect.Proxy;

/**
 * @ClassName: RestRemoteProxy
 * @Description: Rest远程调用代理
 * @Author: wanggeng
 * @Date: 2021/9/18 5:40 下午
 * @Version: 1.0
 */
public class RestRemoteProxy {

    public static <T> T getInstance(Class<T> cls) {
        RestRemoteHandler restRemoteHandler = new RestRemoteHandler();
        Object o = Proxy.newProxyInstance(cls.getClassLoader(), new Class[]{cls}, restRemoteHandler);
        return (T) o;
    }

    public interface IDemo {
        String say();
    }

    public static class DemoImpl implements IDemo {
        @Override
        public String say() {
            return "go";
        }
    }

    public static void main(String[] args) {
        IDemo demo = RestRemoteProxy.getInstance(IDemo.class);
        System.out.println(demo.say());
    }

}
